#pragma rtGlobals=3		// Use modern global access method and strict wave access.

#include <Resize Controls>
#include <SaveRestoreWindowCoords>

constant IgorCLReadWrite = 1
constant IgorCLWriteOnly = 2
constant IgorCLReadOnly = 4
constant IgorCLUseHostPointer = 8
constant IgorCLIsLocalMemory = 16
constant IgorCLIsScalarArgument = 32

Menu "Macros"
	"IgorCL Editor", /Q, SetupProcedureEditor()
End

Function SetupProcedureEditor()
	
	DoWindow /F IgorCLEditor
	if (V_flag != 1)
		string platforms = "\"" + GetOpenCLPlatforms() + "\""
		string deviceNames = "\"" + GetOpenCLDeviceNames(0) + "\""
		
		NewPanel /K=1/W=(150,50,1034,685) /N=IgorCLEditor
		GroupBox GBSourceCode,win=IgorCLEditor,pos={15,1},size={855,468},title="Source Code"
		GroupBox GBSourceCode,win=IgorCLEditor
		GroupBox GBSourceCode,win=IgorCLEditor
		GroupBox GBSourceCode,win=IgorCLEditor
		GroupBox GBSourceCode,userdata(ResizeControlsInfo)= A"!!,B)!!#66!!#De^]6aez!!#](Aon\"q7:^+SDfSN_Aon\"Qzzzzzzzzzzz!!#o2B4uAe7:^+SDfS`i"
		GroupBox GBSourceCode,userdata(ResizeControlsInfo) += A"B4uAezzzzzzzzzzz!!#u:DuaGl7:^+SDfSfqDu]k<zzzzzzzz"
		GroupBox GBSourceCode,userdata(ResizeControlsInfo) += A"zzz!!#?(FEDG<!+]ecDfS0_FEDG<zzzzzzzzzzz!!!"
		DefineGuide EditorLeft={FL,20},EditorRight={FR,-20},EditorTop={FT,20},EditorBottom={FB,-175}
		NewNotebook /N=CodeEditor /F=0 /N=NB0 /W=(116,23,500,307)/FG=(EditorLeft,EditorTop,EditorRight,EditorBottom) /HOST=IgorCLEditor
		
		GroupBox GBCompileOutput,win=IgorCLEditor,pos={14,473},size={856,80},title="Compile output"
		GroupBox GBCompileOutput,win=IgorCLEditor
		GroupBox GBCompileOutput,win=IgorCLEditor
		GroupBox GBCompileOutput,win=IgorCLEditor
		GroupBox GBCompileOutput,userdata(ResizeControlsInfo)= A"!!,An!!#CQJ,hu<!!#?Yz!!#](Aon\"q6Z6g\\Bl%?VF`_SFFA-7XF8u:@zzzzzzzzz!!#o2B4uAe6Z6g\\Bl%?V"
		GroupBox GBCompileOutput,userdata(ResizeControlsInfo) += A"F`_SFFAcgcBQO4Szzzzzzzzz!!#?(FEDG<!,l^nBl%?VF`_SFFB!0tzzzzzzz"
		GroupBox GBCompileOutput,userdata(ResizeControlsInfo) += A"zzz!!#?(FEDG<!,l^nBl%?VF`_SFF@'nfFDl!rzzzzzzzzz!!!"
		DefineGuide CompileOutputTop={FB,-145},CompileOutputBottom={FB,-90},CompileOutputLeft={EditorLeft, 0},CompileOutputRight={EditorRight,0}
		NewNotebook /F=0 /N=NBCompileOutput /W=(226,160,679,480)/FG=(CompileOutputLeft,CompileOutputTop,CompileOutputRight,CompileOutputBottom) /HOST=IgorCLEditor 
		Notebook IgorCLEditor#NBCompileOutput, changeableByCommandOnly=1
		
		PopupMenu PMCodeDestination,win=IgorCLEditor,pos={281,603},size={205,20},bodyWidth=150,title="Destination:",proc=PMCodeDestinationProc
		PopupMenu PMCodeDestination,win=IgorCLEditor,mode=1,popvalue="Save in text wave",value= #"\"Save in text wave;Compile for device;Copy to clipboard as Igor string;Copy to clipboard as C string;\""
		PopupMenu PMCodeDestination,win=IgorCLEditor,userdata(ResizeControlsInfo)= A"!!,HGJ,htQ^]6_r!!#<Xz!!#o2B4uAezzzzzzzzzzzzzz!!#o2B4uAezz"
		PopupMenu PMCodeDestination,win=IgorCLEditor,userdata(ResizeControlsInfo) += A"zzzzzzzzzzzz!!#?(FEDG<zzzzzzzzzzz"
		PopupMenu PMCodeDestination,win=IgorCLEditor,userdata(ResizeControlsInfo) += A"zzz!!#?(FEDG<zzzzzzzzzzzzzz!!!"
		SetVariable SVOutputWaveName,win=IgorCLEditor,pos={501,606},size={200,15},title="Output wave name:"
		SetVariable SVOutputWaveName,win=IgorCLEditor,value= _STR:"W_IgorCLProgram"
		SetVariable SVOutputWaveName,win=IgorCLEditor,userdata(ResizeControlsInfo)= A"!!,I`J,htRJ,hr-!!#<(z!!#o2B4uAezzzzzzzzzzzzzz!!#o2B4uAezz"
		SetVariable SVOutputWaveName,win=IgorCLEditor,userdata(ResizeControlsInfo) += A"zzzzzzzzzzzz!!#?(FEDG<zzzzzzzzzzz"
		SetVariable SVOutputWaveName,win=IgorCLEditor,userdata(ResizeControlsInfo) += A"zzz!!#?(FEDG<zzzzzzzzzzzzzz!!!"
		PopupMenu PMPlatform,win=IgorCLEditor,pos={15,560},size={243,20},bodyWidth=200,title="Platform:"
		PopupMenu PMPlatform,win=IgorCLEditor,mode=1,value= #platforms
		PopupMenu PMPlatform,win=IgorCLEditor,userdata(ResizeControlsInfo)= A"!!,B)!!#Cq!!#B-!!#<Xz!!#](Aon\"Qzzzzzzzzzzzzzz!!#](Aon\"Qzz"
		PopupMenu PMPlatform,win=IgorCLEditor,userdata(ResizeControlsInfo) += A"zzzzzzzzzzzz!!#?(FEDG<zzzzzzzzzzz"
		PopupMenu PMPlatform,win=IgorCLEditor,userdata(ResizeControlsInfo) += A"zzz!!#?(FEDG<zzzzzzzzzzzzzz!!!"
		PopupMenu PMDevice,win=IgorCLEditor,pos={287,560},size={335,20},bodyWidth=300,title="Device:"
		PopupMenu PMDevice,win=IgorCLEditor,mode=1,value= #deviceNames
		PopupMenu PMDevice,win=IgorCLEditor,userdata(ResizeControlsInfo)= A"!!,HJJ,htG!!#BaJ,hm.z!!#o2B4uAezzzzzzzzzzzzzz!!#o2B4uAezz"
		PopupMenu PMDevice,win=IgorCLEditor,userdata(ResizeControlsInfo) += A"zzzzzzzzzzzz!!#?(FEDG<zzzzzzzzzzz"
		PopupMenu PMDevice,win=IgorCLEditor,userdata(ResizeControlsInfo) += A"zzz!!#?(FEDG<zzzzzzzzzzzzzz!!!"
		Button BTTestCompile,win=IgorCLEditor,pos={717,563},size={150,20},proc=BTTestCompileProc,title="Test Compile"
		Button BTTestCompile,win=IgorCLEditor,userdata(ResizeControlsInfo)= A"!!,JD5QF1\\^]6_;!!#<Xz!!#o2B4uAezzzzzzzzzzzzzz!!#o2B4uAezz"
		Button BTTestCompile,win=IgorCLEditor,userdata(ResizeControlsInfo) += A"zzzzzzzzzzzz!!#?(FEDG<zzzzzzzzzzz"
		Button BTTestCompile,win=IgorCLEditor,userdata(ResizeControlsInfo) += A"zzz!!#?(FEDG<zzzzzzzzzzzzzz!!!"
		Button BTSaveOrCompile,win=IgorCLEditor,pos={716,604},size={150,20},title="Save as text",proc=BTSaveOrCompileProc
		Button BTSaveOrCompile,win=IgorCLEditor,userdata(ResizeControlsInfo)= A"!!,JD!!#D'!!#A%!!#<Xz!!#o2B4uAezzzzzzzzzzzzzz!!#o2B4uAezz"
		Button BTSaveOrCompile,win=IgorCLEditor,userdata(ResizeControlsInfo) += A"zzzzzzzzzzzz!!#?(FEDG<zzzzzzzzzzz"
		Button BTSaveOrCompile,win=IgorCLEditor,userdata(ResizeControlsInfo) += A"zzz!!#?(FEDG<zzzzzzzzzzzzzz!!!"
		
		SetWindow IgorCLEditor,hook(ResizeControls)=ResizeControls#ResizeControlsHook
		SetWindow IgorCLEditor,userdata(ResizeControlsInfo)= A"!!*'\"z!!#Dm!!#D.^]4?7zzzzzzzzzzzzzzzzzzzz"
		SetWindow IgorCLEditor,userdata(ResizeControlsInfo) += A"zzzzzzzzzzzzzzzzzzzzzzzzz"
		SetWindow IgorCLEditor,userdata(ResizeControlsInfo) += A"zzzzzzzzzzzzzzzzzzz!!!"
		SetWindow IgorCLEditor,userdata(ResizeControlsGuides)=  "EditorLeft;EditorRight;EditorTop;EditorBottom;CompileOutputTop;CompileOutputBottom;CompileOutputLeft;CompileOutputRight;"
		SetWindow IgorCLEditor,userdata(ResizeControlsInfoEditorLeft)= A":-hTC3^mRnFDl1nAS-$G=%Q.J8S;s^6VKpZBln964&f?Z764FiATBk':Jsbf:JOkT9KFjh:et\"]<(Tk\\3\\iBN7o`,K756hm9KPaE8OQ!&3]g5.9MeM`8Q88W:-(-a3r"
		SetWindow IgorCLEditor,userdata(ResizeControlsInfoEditorRight)= A":-hTC3^mRnFDl1tBkM+$4',!K3_<t&E^NMhA8-.(E][6':dmEFF(KAR85E,T>#.mm5tj<n4&A^O8Q88W:-(?m1cn3-8OQ!%3_!\"/7o`,K75?nc;FO8U:K'ha8P`)B/M]\"A"
		SetWindow IgorCLEditor,userdata(ResizeControlsInfoEditorTop)= A":-hTC3^mRnFDl2!Df@d>8PV<<B5_fX9LWK+FDl1]<*<$d3`U64E]Zff;Ft%f:/jMQ3\\`]m:K'ha8P`)B1,(d[<CoSI0fhd'4%E:B6q&jl4&SL@:et\"]<(Tk\\3\\iBN"
		SetWindow IgorCLEditor,userdata(ResizeControlsInfoEditorBottom)= A":-hTC3^mRnFDl1dDfg)>D*(fj:-(sZDfS3=7:^+SDfRp==\\qOJ<HD_l4%N.F8Qnnb<'a2=0fr3-;b9q[:JNr-2D@3_<CoSI0fhcj4%E:B6q&jl4&SL@:et\"]<(Tk\\3\\<'F2*1"
		SetWindow IgorCLEditor,userdata(ResizeControlsInfoCompileOutput)= A":-hTC3^[h&E+s-\":N^buF`^MqB4uBK=%Q.J8S;s^6VKpZBln964&f?Z764FiATBk':Jsbf:JOkT9KFjh:et\"]<(Tk\\3]K#S4%E:B6q&gk7:^+SDfS`iB4uBK7o`,K75?nc;FO8U:K'ha8P`)B0KT"
	endif
End

Function PMCodeDestinationProc(pa) : PopupMenuControl
	STRUCT WMPopupAction &pa

	switch( pa.eventCode )
		case 2: // mouse up
			Variable popNum = pa.popNum
			String popStr = pa.popStr
			
			string windowName = pa.win
			SetVariable SVOutputWaveName, win=$windowName, disable=0
			StrSwitch (popStr)
				case "Save in text wave":
					Button BTSaveOrCompile,win=$windowName, title="Save as text"
					break
				case "Compile for device":
					Button BTSaveOrCompile,win=$windowName, title="Compile and save"
					break
				case "Copy to clipboard as Igor string":
				case "Copy to clipboard as C string":
					Button BTSaveOrCompile,win=$windowName, title="Copy to clip"
					SetVariable SVOutputWaveName, win=$windowName, disable=1
					break
				default:
					Abort "Unknown destination type"
					break
			EndSwitch
			
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End

Function BTTestCompileProc(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
			// click code here
			string windowName = ba.win
			
			ControlInfo /W=$windowName PMCodeDestination
			string destinationMode = S_Value
			
			ControlInfo /W=$windowName SVOutputWaveName
			string outputWaveName = S_Value
			
			ControlInfo /W=$windowName PMPlatform
			variable platformIndex = V_Value - 1
			
			ControlInfo /W=$windowName PMDevice
			variable deviceIndex = V_Value - 1
			
			string fullName = windowName + "#" + "CodeEditor"
			Notebook $fullName getData=2
			string sourceText = S_Value		
			sourceText = ReplaceString("\r", sourceText, "\n")
			
			KillWaves /Z W_IgorCLCompileDummy
			IgorCLCompile /PLTM=(platformIndex) /DEV=(deviceIndex) /DEST=W_IgorCLCompileDummy /Z sourceText
			KillWaves /Z W_IgorCLCompileDummy
			
			string buildLog = S_BuildLog
			variable err = V_flag
			Notebook $windowName#NBCompileOutput selection={startOfFile, endOfFile}	
			if (err == 0)
				NoteBook $windowName#NBCompileOutput text="COMPILED OK\r" + buildLog,textRGB=(0,0,0)
			else
				NoteBook $windowName#NBCompileOutput text=buildLog,textRGB=(65535,0,0)
			endif
			
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End

Function BTSaveOrCompileProc(ba) : ButtonControl
	STRUCT WMButtonAction &ba

	switch( ba.eventCode )
		case 2: // mouse up
			// click code here
			string windowName = ba.win
			
			ControlInfo /W=$windowName PMCodeDestination
			string destinationMode = S_Value
			
			ControlInfo /W=$windowName SVOutputWaveName
			string outputWaveName = S_Value
			
			ControlInfo /W=$windowName PMPlatform
			variable platformIndex = V_Value - 1
			
			ControlInfo /W=$windowName PMDevice
			variable deviceIndex = V_Value - 1
			
			string fullName = windowName + "#" + "CodeEditor"
			Notebook $fullName getData=2
			string sourceText = S_Value		
			sourceText = ReplaceString("\r", sourceText, "\n")
			
			StrSwitch (destinationMode)
				case "Save in text wave":
					SaveCodeAsTextWave(sourceText, outputWaveName)
					break
				case "Compile for device":
					CompileCodeToBinary(sourceText, platformIndex, deviceIndex, outputWaveName)
					break
				case "Copy to clipboard as Igor string":
					CopyCodeToIgorString(sourceText)
					break
				case "Copy to clipboard as C string":
					CopyCodeToCString(sourceText)
					break
				default:
					Abort "Unknown destination type"
					break
			EndSwitch
			
			break
		case -1: // control being killed
			break
	endswitch

	return 0
End

Function SaveCodeAsTextWave(sourceText, textWaveName)
	String sourceText, textWaveName
	KillWaves /Z $textWaveName
	Make /N=1 /T /O $textWaveName
	wave /T textWave = $textWaveName
	textWave[0] = sourceText
End

Function CompileCodeToBinary(sourceText, platformIndex, deviceIndex, binaryWaveName)
	string sourceText
	variable platformIndex, deviceIndex
	string binaryWaveName
	
	KillWaves /Z $binaryWaveName
	IgorCLCompile /PLTM=(platformIndex) /DEV=(deviceIndex) /DEST=$binaryWaveName sourceText
End

Function CopyCodeToIgorString(sourceText)
	string sourceText
	
	// replace all possible line endings with '\n'
	sourceText = ReplaceString("\r\n", sourceText, "\n")
	sourceText = ReplaceString("\r", sourceText, "\n")
	variable sourceLen = strlen(sourceText)
	
	string igorCodeString = "string igorCLCode = \"\"\r"
	
	variable strIndex = 0, nextLoc, maxLineLength = 350
	string thisLine
	for ( ; strIndex < sourceLen; )
		nextLoc = StrSearch(sourceText, "\n", strIndex)
		if (nextLoc == -1)
			nextLoc = sourceLen - 1
		endif
		if (nextLoc - strIndex + 1 > maxLineLength)
			nextLoc = strIndex + maxLineLength - 1
		endif
		thisLine = sourceText[strIndex, nextLoc]
		thisLine = ReplaceString("\n", thisLine, "\\n")
		igorCodeString += "igorCLCode += \"" + thisLine + "\"\r"
		strIndex = nextLoc + 1
	endfor
	
	PutScrapText igorCodeString
End

Function CopyCodeToCString(sourceText)
	string sourceText
	
	// replace all possible line endings with '\n'
	sourceText = ReplaceString("\r\n", sourceText, "\n")
	sourceText = ReplaceString("\r", sourceText, "\n")
	variable sourceLen = strlen(sourceText)
	
	string igorCodeString = "const char* kernelSource = \"\"\r"
	
	variable strIndex = 0, nextLoc, maxLineLength = 350
	string thisLine
	for ( ; strIndex < sourceLen; )
		nextLoc = StrSearch(sourceText, "\n", strIndex)
		if (nextLoc == -1)
			nextLoc = sourceLen - 1
		endif
		if (nextLoc - strIndex + 1 > maxLineLength)
			nextLoc = strIndex + maxLineLength - 1
		endif
		thisLine = sourceText[strIndex, nextLoc]
		thisLine = ReplaceString("\n", thisLine, "\\n")
		igorCodeString += "\"" + thisLine + "\"\r"
		strIndex = nextLoc + 1
	endfor
	igorCodeString += ";"
	
	PutScrapText igorCodeString
End

Function /S GetOpenCLPlatforms()
	string platforms = ""
	
	IgorCLInfo
	wave /T M_OpenCLPlatforms
	
	variable i
	for (i = 0; i < DimSize(M_OpenCLPlatforms, 1); i+=1)
		platforms += M_OpenCLPlatforms[0][i] + ";"
	endfor
	
	return platforms
End

Function /S GetOpenCLDeviceNames(platformIndex)
	variable platformIndex
	string devices = ""
	
	IgorCLInfo
	string deviceWaveName = "M_OpenCLDevices" + num2istr(platformIndex)
	wave /T M_devices = $deviceWaveName
	
	variable i
	for (i = 0; i < DimSize(M_devices, 1); i+=1)
		devices += M_devices[1][i] + ";"
	endfor
	
	return devices
End